#include "hbqtgui.ch"
#include "hbclass.ch"
#include "common.ch"

FUNCTION Main()

  LOCAL oMainForm, oTextBox1, oTextBox2
  
  hbqt_errorsys()
  
  WITH OBJECT oMainForm := LQTWINDOW():New()
    :Title       := "Form Title"
    :Width       := 800
    :Height      := 600
    :OnInit      := {|| FrmOnInit() }
    :OnClick     := {|| FrmOnClick() }
    :OnRelease   := {|| FrmOnRelease() }
    :OnInteractiveClose   := {|| FrmOnIntClose() } // this is the last event connected to Qt Close event: for this reason THIS is fired on
                                                   // change order with OnRelease and you see bOnRelease block :))

   WITH OBJECT oTextBox1 := LQTTEXTBOX():New()
     :Row         := 40
     :Col         := 40
     :Width       := 200
     :Height      := 25
     :Value       := ""
     :OnEnter     :=  {|| Tx1OnEnter( oTextBox1:Value ) }
   END WIDTH

   WITH OBJECT oTextBox2 := LQTTEXTBOX():New()
     :Row         := 90
     :Col         := 40
     :Width       := 200
     :Height      := 25
     :Value       := "preset value"
     :OnEnter     :=  {|| Tx2OnEnter( oTextBox2:Value ) }
   END WIDTH

   WITH OBJECT LQTBUTTON():New()
     :Row         := 200
     :Col         := 40
     :Width       := 150
     :Height      := 40
     :Caption     := "&Push Enter or Click here"
     :OnClick     :=  {|| Bt1OnClick() }
     :OnEnter     :=  {|| Bt1OnEnter() }
   END WIDTH

  END WITH
  
  oMainForm:Center()
  oMainForm:Activate()
  
  HB_SYMBOL_UNUSED( oTextBox1 )
  HB_SYMBOL_UNUSED( oTextBox2 )

RETURN NIL

STATIC FUNCTION FrmOnInit()

  MsgStop( "OnInit block", "Form" )

RETURN NIL

STATIC FUNCTION FrmOnClick()

  MsgStop( "OnClick block", "Form" )

RETURN NIL

STATIC FUNCTION FrmOnRelease()

  MsgStop( "OnRelease block", "Form" )

RETURN NIL

STATIC FUNCTION FrmOnIntClose()

  MsgStop( "OnInteractiveClose block", "Form" )

RETURN NIL

STATIC FUNCTION Bt1OnClick()

  MsgStop( "OnClick block", "Button1" )

RETURN NIL

STATIC FUNCTION Bt1OnEnter()

  MsgStop( "OnEnter block", "Button1" )

RETURN NIL

STATIC FUNCTION Tx1OnEnter( xValue )

  MsgStop( "OnEnter block", "TextBox1" )
  MsgStop( xValue, "TextBox1" )

RETURN NIL

STATIC FUNCTION Tx2OnEnter()

  MsgStop( "OnEnter block", "TextBox2" )

RETURN NIL

/*==============================================================================
 LQTSHARED class begin
==============================================================================*/
CLASS LQTSHARED

  CLASS VAR lQtStarted                           INIT .F.      SHARED
  CLASS VAR sQtApplication                       INIT NIL      SHARED
  CLASS VAR oDefaultParent                       INIT NIL      SHARED

ENDCLASS

/*==============================================================================
 LQTSTART class begin
==============================================================================*/
CLASS LQTSTART FROM LQTSHARED

  METHOD Start

ENDCLASS

//      LQTSTART class Start Method
METHOD LQTSTART:Start()

  IF ::lQtStarted == .F.
    ::lQtStarted     := .T.
    ::sQtApplication := QApplication()
  ENDIF

RETURN Self

/*==============================================================================
 LQTBASIC class begin
==============================================================================*/
CLASS LQTBASIC

  DATA oQTObject                                 INIT NIL
  DATA oParent                                   INIT NIL
  DATA aControls                                 INIT {}

  DATA cCaption                                  INIT NIL
  DATA nCol                                      INIT NIL
  DATA nHeight                                   INIT NIL
  DATA nMaxLength                                INIT NIL
  DATA cName                                     INIT NIL
  DATA nRow                                      INIT NIL
  DATA cTitle                                    INIT NIL
  DATA xValue                                    INIT NIL
  DATA nWidth                                    INIT NIL

  DATA bOnClick                                  INIT NIL
  DATA bOnEnter                                  INIT NIL
  DATA bOnGotFocus                               INIT NIL
  DATA bOnInit                                   INIT NIL
  DATA bOnInteractiveClose                       INIT NIL
  DATA bOnLostFocus                              INIT NIL
  DATA bOnMouseClick                             INIT NIL
  DATA bOnMouseDrag                              INIT NIL
  DATA bOnRelease                                INIT NIL

  METHOD GetActQtWin
  METHOD Move
  METHOD MouseClickProcess
  METHOD Release
  METHOD Resize
  METHOD SendEvent

  METHOD Col                                     SETGET
  METHOD Height                                  SETGET
  METHOD Row                                     SETGET
  METHOD Width                                   SETGET
  METHOD OnClick                                 SETGET
  METHOD OnGotFocus                              SETGET
  METHOD OnInit                                  SETGET
  METHOD OnInteractiveClose                      SETGET
  METHOD OnLostFocus                             SETGET
  METHOD OnMouseClick                            SETGET
  METHOD OnMouseDrag                             SETGET
  METHOD OnRelease                               SETGET

ENDCLASS

//      LQTBASIC class GetActQtWin Method
METHOD LQTBASIC:GetActQtWin()
// see Qt activeWindow at http://doc.qt.nokia.com/4.4/qapplication.html
RETURN ::sQtApplication:activeWindow()

//      LQTBASIC class Move Method
METHOD LQTBASIC:Move( nRow, nCol )

  IF PCOUNT() == 2 .AND. VALTYPE( nRow ) == "N" .AND. VALTYPE( nCol ) == "N"
    ::nRow := nRow
    ::nCol := nCol
  ENDIF
  IF VALTYPE( ::nRow ) == "N" .AND. VALTYPE( ::nCol ) == "N"
   ::oQtObject:Move( ::nCol, ::nRow )
  ENDIF

RETURN Self

//      LQTBASIC class MouseClickProcess Method
METHOD LQTBASIC:MouseClickProcess( oEvent )

  IF oEvent:button() == Qt_LeftButton
    EVAL( ::bOnMouseClick )
  ENDIF

RETURN NIL

//      LQTBASIC class Release Method
METHOD LQTBASIC:Release()
  
  ::oQTObject:close()

RETURN Self

//      LQTBASIC class Resize Method
METHOD LQTBASIC:Resize( nWidth, nHeight )

  IF PCOUNT() == 2 .AND. VALTYPE( nWidth ) == "N" .AND. VALTYPE( nHeight ) == "N"
    ::nWidth := nWidth
    ::nHeight := nHeight
  ENDIF
  IF VALTYPE( ::nWidth ) == "N" .AND. VALTYPE( ::nHeight ) == "N"
   ::oQtObject:resize( ::nWidth, ::nHeight )
  ENDIF

RETURN Self

//      LQTBASIC class SendEvent Method
METHOD LQTBASIC:SendEvent( nKey, nModifier, oQtActWin )

  LOCAL oKey

  nKey      := IIF( VALTYPE( nKey )      == "N", nKey,      Qt_Key_Tab ) // by default use Tab key
  nModifier := IIF( VALTYPE( nModifier ) == "N", nModifier, Qt_NoModifier ) // by default don't use modifier (Shit, Ctrl, Alt )
  oQtActWin := IIF( VALTYPE( oQtActWin ) == "U", ::GetActQtWin(), oQtActWin ) // by default use Qt Active Window

// see Qt QKeyEvent at http://doc.qt.nokia.com/latest/qkeyevent.html
  oKey      := QKeyEvent( QEvent_KeyPress, nKey, nModifier, 0, 0)

// see Qt sendEvent at http://doc.qt.nokia.com/latest/eventsandfilters.html
  ::sQtApplication:sendEvent( oQtActWin, oKey )
// see Qt processEvents at http://doc.qt.nokia.com/latest/qcoreapplication.html
  ::sQtApplication:processEvents()

RETURN .T.

//      LQTBASIC class Col Method
METHOD LQTBASIC:Col( nCol )

  IF PCOUNT() == 0
    RETURN ::nCol
  ELSEIF VALTYPE( nCol ) == "N"
    ::nCol := nCol
    ::Move()
  ENDIF

RETURN Self

//      LQTBASIC class Height Method
METHOD LQTBASIC:Height( nHeight )

  IF PCOUNT() == 0
    RETURN ::nHeight
  ELSEIF VALTYPE( nHeight ) == "N"
    ::nHeight := nHeight
    ::Resize()
  ENDIF

RETURN Self

//      LQTBASIC class Row Method
METHOD LQTBASIC:Row( nRow )

  IF PCOUNT() == 0
    RETURN ::nRow
  ELSEIF VALTYPE( nRow ) == "N"
    ::nRow := nRow
    ::Move()
  ENDIF

RETURN Self

//      LQTBASIC class Width Method
METHOD LQTBASIC:Width( nWidth )

  IF PCOUNT() == 0
    RETURN ::nWidth
  ELSEIF VALTYPE( nWidth ) == "N"
    ::nWidth := nWidth
    ::Resize()
  ENDIF

RETURN Self

//      LQTBASIC class OnClick Method
METHOD LQTBASIC:OnClick( bOnClick )

  IF PCOUNT() == 0
    RETURN ::bOnClick
  ELSEIF VALTYPE( bOnClick ) == "B"
    ::bOnClick := bOnClick
    ::oQtObject:connect( QEvent_MouseButtonPress, {|| EVAL( ::bOnClick ) } )
  ENDIF

RETURN Self

//      LQTBASIC class OnGotFocus Method
METHOD LQTBASIC:OnGotFocus( bOnGotFocus )

  IF PCOUNT() == 0
    RETURN ::bOnGotFocus
  ELSEIF VALTYPE( bOnGotFocus ) == "B"
    ::bOnGotFocus := bOnGotFocus
    IF ::oQTObject:focusPolicy() == Qt_NoFocus
      ::oQTObject:setFocusPolicy( Qt_StrongFocus )
    ENDIF
    ::oQTObject:connect( QEvent_FocusIn , {|| EVAL( ::bOnGotFocus ) } )
  ENDIF

RETURN Self

//      LQTBASIC class OnInit Method
METHOD LQTBASIC:OnInit( bOnInit )

  IF PCOUNT() == 0
    RETURN ::bOnInit
  ELSEIF VALTYPE( bOnInit ) == "B"
    ::bOnInit := bOnInit
    ::oQtObject:connect( QEvent_Show, {|| EVAL( ::bOnInit ) } )
  ENDIF

RETURN Self

//      LQTBASIC class OnInteractiveClose Method
METHOD LQTBASIC:OnInteractiveClose( bOnInteractiveClose )

  IF PCOUNT() == 0
    RETURN ::bOnInteractiveClose
  ELSEIF VALTYPE( bOnInteractiveClose ) == "B"
    ::bOnInteractiveClose := bOnInteractiveClose
    ::oQtObject:connect( QEvent_Close, {|| EVAL( ::bOnInteractiveClose ) } )
  ENDIF

RETURN Self

//      LQTBASIC class OnLostFocus Method
METHOD LQTBASIC:OnLostFocus( bOnLostFocus )

  IF PCOUNT() == 0
    RETURN ::bOnLostFocus
  ELSEIF VALTYPE( bOnLostFocus ) == "B"
    ::bOnLostFocus := bOnLostFocus
    IF ::oQTObject:focusPolicy() == Qt_NoFocus
      ::oQTObject:setFocusPolicy( Qt_StrongFocus )
    ENDIF
    ::oQTObject:connect( QEvent_FocusOut , {|| EVAL( ::bOnLostFocus ) } )
  ENDIF

RETURN Self

//      LQTBASIC class OnMouseClick Method
METHOD LQTBASIC:OnMouseClick( bOnMouseClick )

  IF PCOUNT() == 0
    RETURN ::bOnMouseClick
  ELSEIF VALTYPE( bOnMouseClick ) == "B"
    ::bOnMouseClick := bOnMouseClick
    ::oQtObject:connect( QEvent_MouseButtonRelease, {|e| ::MouseClickProcess( e ) } )
  ENDIF

RETURN Self

//      LQTBASIC class OnMouseDrag Method
METHOD LQTBASIC:OnMouseDrag( bOnMouseDrag )

  IF PCOUNT() == 0
    RETURN ::bOnMouseDrag
  ELSEIF VALTYPE( bOnMouseDrag ) == "B"
    ::bOnMouseDrag := bOnMouseDrag
    ::oQtObject:connect( QEvent_DragEnter, {|| EVAL( ::bOnMouseDrag ) } )
  ENDIF

RETURN Self

//      LQTBASIC class OnRelease Method
METHOD LQTBASIC:OnRelease( bOnRelease )

  IF PCOUNT() == 0
    RETURN ::bOnRelease
  ELSEIF VALTYPE( bOnRelease ) == "B"
    ::bOnRelease := bOnRelease
    ::oQtObject:connect( QEvent_Close, {|| EVAL( ::bOnRelease ) } )
  ENDIF

RETURN Self

/*==============================================================================
 LQTWINDOW class begin
==============================================================================*/
CLASS LQTWINDOW FROM LQTSHARED, LQTBASIC

  METHOD New
  METHOD Activate
  METHOD ProcessEnter
  METHOD Center

  METHOD Title                                   SETGET
  METHOD OnEnter                                 SETGET

ENDCLASS

//      LQTWINDOW class New Method
METHOD LQTWINDOW:New()

  LQTSTART():Start()

  ::oParent := Self
  ::oDefaultParent := Self

  ::oQtObject := QMainWindow()
  
RETURN Self

//      LQTWINDOW class Activate Method
METHOD LQTWINDOW:Activate()

  ::oQTObject:setFocusPolicy( Qt_StrongFocus )
  ::oQtObject:Show()

   ::sQtApplication:exec()

RETURN Self

//      LQTWINDOW class ProcessEnter Method
METHOD LQTWINDOW:ProcessEnter( oEvent )

  LOCAL nKey := oEvent:key()
  LOCAL nModifiers := oEvent:modifiers()

  IF nKey == Qt_Key_Return .OR. nKey == Qt_Key_Enter
    EVAL( ::bOnEnter )
    RETURN .T.
  ENDIF
  
  HB_SYMBOL_UNUSED( nModifiers )

RETURN .F.

//      LQTWINDOW class Center Method
METHOD LQTWINDOW:Center()

   IF VALTYPE( ::nWidth ) == "N" .AND. VALTYPE( ::nHeight ) == "N"
     ::Move( INT( ( GetDesktopFreeHeight() - ::nHeight ) / 2 ) , INT( ( GetDesktopFreeWidth() - ::nWidth ) / 2 ) )
   ENDIF

RETURN Self

//      LQTWINDOW class Title Method
METHOD LQTWINDOW:Title( cTitle )

  IF PCOUNT() == 0
    RETURN ::cTitle
  ELSEIF VALTYPE( cTitle ) == "C"
    ::cTitle := cTitle
    ::oQtObject:setWindowTitle( ::cTitle )
  ENDIF

RETURN Self

//      LQTWINDOW class OnEnter Method
METHOD LQTWINDOW:OnEnter( bOnEnter )

  IF PCOUNT() == 0
    RETURN ::bOnEnter
  ELSEIF VALTYPE( bOnEnter ) == "B"
    ::bOnEnter := bOnEnter
    ::oQtObject:connect( QEvent_KeyPress, {|e| ::ProcessEnter( e ) } )
  ENDIF

RETURN Self

/*==============================================================================
 LQTBUTTON class begin
==============================================================================*/
CLASS LQTBUTTON FROM LQTSHARED, LQTBASIC

  METHOD New
  METHOD ProcessEnter

  METHOD Caption                                 SETGET
  METHOD OnEnter                                 SETGET

ENDCLASS

//      LQTBUTTON class New Method
METHOD LQTBUTTON:New()

  LOCAL oParent
  
  LQTSTART():Start()

  IF hb_isobject( oParent := hb_qwith() )
   ::oParent    := oParent
  ELSE
   ::oParent := ::oDefaultParent
  ENDIF

  AADD( ::oParent:aControls, Self )

  ::oQTObject := QPushButton( ::oParent:oQTObject )
//  ::oQTObject:setFocusPolicy( Qt_StrongFocus )

RETURN Self

//      LQTBUTTON class ProcessEnter Method
METHOD LQTBUTTON:ProcessEnter( oEvent )

  LOCAL nKey := oEvent:key()
  LOCAL nModifiers := oEvent:modifiers()

  IF nKey == Qt_Key_Return .OR. nKey == Qt_Key_Enter
    EVAL( ::bOnEnter )
    RETURN .T.
  ENDIF
  
  HB_SYMBOL_UNUSED( nModifiers )

RETURN .F.

//      LQTBUTTON class Caption Method
METHOD LQTBUTTON:Caption( cCaption )

  IF PCOUNT() == 0
    RETURN ::cCaption
  ELSEIF VALTYPE( cCaption ) == "C"
    ::cCaption := cCaption
    ::oQTObject:setText( ::cCaption )
  ENDIF

RETURN Self

//      LQTBUTTON class OnEnter Method
METHOD LQTBUTTON:OnEnter( bOnEnter )

  IF PCOUNT() == 0
    RETURN ::bOnEnter
  ELSEIF VALTYPE( bOnEnter ) == "B"
    ::bOnEnter := bOnEnter
    ::oQtObject:connect( QEvent_KeyPress, {|e| ::ProcessEnter( e ) } )
//    ::oQtObject:connect( QEvent_KeyPress, {|| EVAL( ::bOnEnter ) } )
  ENDIF

RETURN Self

/*==============================================================================
 LQTTEXTBOX class begin
==============================================================================*/
CLASS LQTTEXTBOX FROM LQTSHARED, LQTBASIC

  METHOD New
  METHOD ProcessEnter

  METHOD MaxLength                               SETGET
  METHOD Value                                   SETGET
  METHOD OnEnter                                 SETGET

ENDCLASS

//      LQTTEXTBOX class New Method
METHOD LQTTEXTBOX:New()

  LOCAL oParent

  LQTSTART():Start()

  IF hb_isobject( oParent := hb_qwith() )
   ::oParent    := oParent
  ELSE
   ::oParent := ::oDefaultParent
  ENDIF

  AADD( ::oParent:aControls, Self )

  ::oQTObject := QLineEdit( ::oParent:oQTObject )
//  ::oQTObject:setFocusPolicy( Qt_StrongFocus )

RETURN Self

//      LQTTEXTBOX class ProcessEnter Method
METHOD LQTTEXTBOX:ProcessEnter()

  IF VALTYPE( ::bOnEnter ) == "B"
    EVAL( ::bOnEnter )
  ENDIF

  ::SendEvent( Qt_Key_Tab, Qt_NoModifier )

RETURN .F.

//      LQTTEXTBOX class OnEnter Method
METHOD LQTTEXTBOX:OnEnter( bOnEnter )

  IF PCOUNT() == 0
    RETURN ::bOnEnter
  ELSEIF VALTYPE( bOnEnter ) == "B"
    ::bOnEnter := bOnEnter
// this work but: 1) signal is emitted twice when lost focus
//    ::oQtObject:connect( "editingFinished()", {|| EVAL( ::bOnEnter ) } )
// it's seem these work fine
//    ::oQtObject:connect( "returnPressed()", {|| EVAL( ::bOnEnter ) } )
    ::oQtObject:connect( "returnPressed()", {|| ::ProcessEnter() } )
  ENDIF

RETURN Self

//      LQTTEXTBOX class MaxLength Method
METHOD LQTTEXTBOX:MaxLength( nMaxLength )

  IF PCOUNT() == 0
    RETURN ::nMaxLength
  ELSEIF VALTYPE( nMaxLength ) == "N"
    ::nMaxLength := nMaxLength
    ::oQTObject:setMaxLength( ::nMaxLength )
  ENDIF

RETURN Self

//      LQTTEXTBOX class Value Method
METHOD LQTTEXTBOX:Value( xValue )

  IF PCOUNT() == 0
    ::xValue := ::oQTObject:text()
    RETURN ::xValue
  ELSE
    ::xValue := IIF( VALTYPE( xValue ) == "C", xValue, "" )
    ::oQTObject:setText( ::xValue )
  ENDIF

RETURN Self

/*==============================================================================
 Miscellaneous functions
==============================================================================*/
FUNCTION GetDesktopWidth()
RETURN QDesktopWidget():screenGeometry( -1 ):width()

FUNCTION GetDesktopHeight()
RETURN QDesktopWidget():screenGeometry( -1 ):height()

FUNCTION GetDesktopFreeHeight()
RETURN QDesktopWidget():availableGeometry( -1 ):height()

FUNCTION GetDesktopFreeWidth()
RETURN QDesktopWidget():availableGeometry( -1 ):width()

FUNCTION MsgStop( cText, cTitle )

 LOCAL oMessageBox, xReturn
 
 cText := IIF( VALTYPE( cText ) == "C", cText, "UnTexted" )
 cTitle := IIF( VALTYPE( cTitle ) == "C", cTitle, "UnTitled" )

 oMessageBox := QMessageBox()
 oMessageBox:setText( "<b>"+ cText +"</b>" )
 oMessageBox:setWindowFlags( Qt_Dialog )
 oMessageBox:setWindowTitle( cTitle )
 oMessageBox:setStandardButtons( QMessageBox_Ok )
 oMessageBox:setDefaultButton( QMessageBox_Ok )
 oMessageBox:setIcon( QMessageBox_Critical )

 xReturn := oMessageBox:exec()

 oMessageBox := NIL
 hb_gcall()

RETURN xReturn

/*
source code from xbpgeneric.prg used in xbpsle.prg
 FUNCTION PostAppEvent( nEvent, mp1, mp2, oXbp )

   HB_SYMBOL_UNUSED( mp2 )

   DEFAULT oXbp TO SetAppWindow()

   IF nEvent == xbeP_Keyboard
      QApplication():sendEvent( oXbp:oWidget, QKeyEvent( QEvent_KeyPress, hbxbp_appEventToQKeyEvent( mp1 ), hbxbp_appEventModifier( mp1 ) ) )
   ELSE
      SetAppEvent( nEvent, mp1, mp2, oXbp )
   ENDIF

   RETURN .T.
*/
